<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Simulation Utilities</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__simulationutil.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Simulation Utilities</div>  </div>
</div><!--header-->
<div class="contents">

<p>These are free functions and utility classes in the Simulation library.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga5821a4ca8e6fe9b0cb2b5492665b5dc0"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API SimTK::State&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga5821a4ca8e6fe9b0cb2b5492665b5dc0">OpenSim::simulate</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const SimTK::State &amp;initialState, double finalTime, bool saveStatesFile=false)</td></tr>
<tr class="memdesc:ga5821a4ca8e6fe9b0cb2b5492665b5dc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Simulate a model from an initial state and return the final state.  <a href="group__simulationutil.html#ga5821a4ca8e6fe9b0cb2b5492665b5dc0">More...</a><br /></td></tr>
<tr class="separator:ga5821a4ca8e6fe9b0cb2b5492665b5dc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga871b1293a7c10c0d9f7358b0d7db83ed"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga871b1293a7c10c0d9f7358b0d7db83ed">OpenSim::updateStateLabels40</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, std::vector&lt; std::string &gt; &amp;labels)</td></tr>
<tr class="memdesc:ga871b1293a7c10c0d9f7358b0d7db83ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update a vector of state labels (in place) to use post-4.0 state paths instead of pre-4.0 state names.  <a href="group__simulationutil.html#ga871b1293a7c10c0d9f7358b0d7db83ed">More...</a><br /></td></tr>
<tr class="separator:ga871b1293a7c10c0d9f7358b0d7db83ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf356001ef168c7f34808f60e493b2b05"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::unique_ptr&lt; <a class="el" href="classOpenSim_1_1Storage.html">Storage</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaf356001ef168c7f34808f60e493b2b05">OpenSim::updatePre40KinematicsStorageFor40MotionType</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;pre40Model, const <a class="el" href="classOpenSim_1_1Storage.html">Storage</a> &amp;kinematics)</td></tr>
<tr class="memdesc:gaf356001ef168c7f34808f60e493b2b05"><td class="mdescLeft">&#160;</td><td class="mdescRight">Not available through scripting.  <a href="group__simulationutil.html#gaf356001ef168c7f34808f60e493b2b05">More...</a><br /></td></tr>
<tr class="separator:gaf356001ef168c7f34808f60e493b2b05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3393a1f7ac64c05305059ed37b2810f3"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga3393a1f7ac64c05305059ed37b2810f3">OpenSim::updatePre40KinematicsFilesFor40MotionType</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const std::vector&lt; std::string &gt; &amp;filePaths, std::string suffix=&quot;_updated&quot;)</td></tr>
<tr class="memdesc:ga3393a1f7ac64c05305059ed37b2810f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function can be used to upgrade MOT files generated with versions before 4.0 in which some data columns are associated with coordinates that were incorrectly marked as Rotational (rather than Coupled).  <a href="group__simulationutil.html#ga3393a1f7ac64c05305059ed37b2810f3">More...</a><br /></td></tr>
<tr class="separator:ga3393a1f7ac64c05305059ed37b2810f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa56d59a1be9785c9b51e65716ab4ec66"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaa56d59a1be9785c9b51e65716ab4ec66">OpenSim::updateSocketConnecteesBySearch</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:gaa56d59a1be9785c9b51e65716ab4ec66"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function attempts to update the connectee path for any <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> anywhere in the model whose connectee path does not point to an existing component.  <a href="group__simulationutil.html#gaa56d59a1be9785c9b51e65716ab4ec66">More...</a><br /></td></tr>
<tr class="separator:gaa56d59a1be9785c9b51e65716ab4ec66"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga171fc46f228eddcb18c329f9b2b291fe"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga171fc46f228eddcb18c329f9b2b291fe">OpenSim::createStateVariableNamesInSystemOrder</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:ga171fc46f228eddcb18c329f9b2b291fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">The map provides the index of each state variable in SimTK::State::getY() from its each state variable path string.  <a href="group__simulationutil.html#ga171fc46f228eddcb18c329f9b2b291fe">More...</a><br /></td></tr>
<tr class="separator:ga171fc46f228eddcb18c329f9b2b291fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4cab0157fb7a49b050ca96aa39fac757"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga4cab0157fb7a49b050ca96aa39fac757">OpenSim::createStateVariableNamesInSystemOrder</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, std::unordered_map&lt; int, int &gt; &amp;yIndexMap)</td></tr>
<tr class="memdesc:ga4cab0157fb7a49b050ca96aa39fac757"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as above, but you can obtain a map from the returned state variable names to the index in SimTK::State::getY() that accounts for empty slots in Y.  <a href="group__simulationutil.html#ga4cab0157fb7a49b050ca96aa39fac757">More...</a><br /></td></tr>
<tr class="separator:ga4cab0157fb7a49b050ca96aa39fac757"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga49570bae937f5adf405c811da8ed9329"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::unordered_map&lt; std::string, int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#ga49570bae937f5adf405c811da8ed9329">OpenSim::createSystemYIndexMap</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:ga49570bae937f5adf405c811da8ed9329"><td class="mdescLeft">&#160;</td><td class="mdescRight">The map provides the index of each state variable in SimTK::State::getY() from its state variable path string.  <a href="group__simulationutil.html#ga49570bae937f5adf405c811da8ed9329">More...</a><br /></td></tr>
<tr class="separator:ga49570bae937f5adf405c811da8ed9329"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaae85359eb9db792e3cc9d4a673e20086"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaae85359eb9db792e3cc9d4a673e20086">OpenSim::createControlNamesFromModel</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, std::vector&lt; int &gt; &amp;modelControlIndices)</td></tr>
<tr class="memdesc:gaae85359eb9db792e3cc9d4a673e20086"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a vector of control names based on the actuators in the model for which appliesForce == True.  <a href="group__simulationutil.html#gaae85359eb9db792e3cc9d4a673e20086">More...</a><br /></td></tr>
<tr class="separator:gaae85359eb9db792e3cc9d4a673e20086"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaecd17fb05e682cd47504c7a2fafc223e"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaecd17fb05e682cd47504c7a2fafc223e">OpenSim::createControlNamesFromModel</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:gaecd17fb05e682cd47504c7a2fafc223e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as above, but when there is no mapping to the modelControlIndices.  <a href="group__simulationutil.html#gaecd17fb05e682cd47504c7a2fafc223e">More...</a><br /></td></tr>
<tr class="separator:gaecd17fb05e682cd47504c7a2fafc223e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gada84ed9ec5e455b9861259845f7454ed"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API std::unordered_map&lt; std::string, int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gada84ed9ec5e455b9861259845f7454ed">OpenSim::createSystemControlIndexMap</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:gada84ed9ec5e455b9861259845f7454ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">The map provides the index of each control variable in the SimTK::Vector returned by Model::getControls(), using the control name as the key.  <a href="group__simulationutil.html#gada84ed9ec5e455b9861259845f7454ed">More...</a><br /></td></tr>
<tr class="separator:gada84ed9ec5e455b9861259845f7454ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaaf7020b9b0d7d879e960cd5c2507e45"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaaaf7020b9b0d7d879e960cd5c2507e45">OpenSim::checkOrderSystemControls</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:gaaaf7020b9b0d7d879e960cd5c2507e45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Throws an exception if the order of the controls in the model is not the same as the order of the actuators in the model.  <a href="group__simulationutil.html#gaaaf7020b9b0d7d879e960cd5c2507e45">More...</a><br /></td></tr>
<tr class="separator:gaaaf7020b9b0d7d879e960cd5c2507e45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaafa30bfd02f4d146b9ed2e3c19d9fef5"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gaafa30bfd02f4d146b9ed2e3c19d9fef5">OpenSim::checkLabelsMatchModelStates</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const std::vector&lt; std::string &gt; &amp;labels)</td></tr>
<tr class="memdesc:gaafa30bfd02f4d146b9ed2e3c19d9fef5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Throws an exception if any label in the provided list does not match any state variable names in the model.  <a href="group__simulationutil.html#gaafa30bfd02f4d146b9ed2e3c19d9fef5">More...</a><br /></td></tr>
<tr class="separator:gaafa30bfd02f4d146b9ed2e3c19d9fef5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabadb22afcecdebfaa78d9a95bd35d336"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:gabadb22afcecdebfaa78d9a95bd35d336"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; T &gt;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">OpenSim::analyze</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> model, const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;statesTable, const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;controlsTable, const std::vector&lt; std::string &gt; &amp;outputPaths, const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;discreteVariablesTable={})</td></tr>
<tr class="memdesc:gabadb22afcecdebfaa78d9a95bd35d336"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the requested outputs using the model in the problem and the provided states and controls tables.  <a href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336">More...</a><br /></td></tr>
<tr class="separator:gabadb22afcecdebfaa78d9a95bd35d336"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad093fdec14dd81460d5b8a698f7e0e1a"><td class="memItemLeft" align="right" valign="top">OSIMSIMULATION_API <a class="el" href="namespaceOpenSim.html#aca67cce5245fc8a1ac274999aa98deb6">TimeSeriesTableVec3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__simulationutil.html#gad093fdec14dd81460d5b8a698f7e0e1a">OpenSim::createSyntheticIMUAccelerationSignals</a> (const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;statesTable, const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;controlsTable, const std::vector&lt; std::string &gt; &amp;framePaths)</td></tr>
<tr class="memdesc:gad093fdec14dd81460d5b8a698f7e0e1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate "synthetic" acceleration signals equivalent to signals recorded from inertial measurement units (IMUs).  <a href="group__simulationutil.html#gad093fdec14dd81460d5b8a698f7e0e1a">More...</a><br /></td></tr>
<tr class="separator:gad093fdec14dd81460d5b8a698f7e0e1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>These are free functions and utility classes in the Simulation library. </p>
<h2 class="groupheader">Function Documentation</h2>
<a id="gabadb22afcecdebfaa78d9a95bd35d336"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gabadb22afcecdebfaa78d9a95bd35d336">&#9670;&nbsp;</a></span>analyze()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt;T&gt; OpenSim::analyze </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>statesTable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>controlsTable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>outputPaths</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>discreteVariablesTable</em> = <code>{}</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculate the requested outputs using the model in the problem and the provided states and controls tables. </p>
<p>The controls table is used to set the model's controls vector. We assume the states and controls tables contain the same time points. The output paths can be regular expressions. For example, ".*activation" gives the activation of all muscles.</p>
<p>The output paths must correspond to outputs that match the type provided in the template argument, otherwise they are not included in the report.</p>
<p>Controls missing from the controls table are given a value of 0.</p>
<p>If you analysis depends on the values of discrete variables in the state, you may provide those values via the optional argument "discreteVariablesTable". This table should contain column labels with the following format: &lt;path_to_component&gt;/&lt;discrete_var_name&gt;. For example, "/forceset/muscle/implicitderiv_normalized_tendon_force".</p>
<dl class="section note"><dt>Note</dt><dd>The provided trajectory is not modified to satisfy kinematic constraints, but SimTK::Motions in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a> (e.g., <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a>) are applied. Therefore, this function expects that you've provided a trajectory that already satisfies kinematic constraints. If your provided trajectory does not satisfy kinematic constraints, many outputs will be incorrect. For example, in a model with a patella whose location is determined by a <a class="el" href="classOpenSim_1_1CoordinateCouplerConstraint.html">CoordinateCouplerConstraint</a>, the length of a muscle that crosses the patella will be incorrect. </dd></dl>
<dl class="section examples"><dt>Examples</dt><dd><a class="el" href="exampleHangingMuscle_8cpp-example.html#a2">exampleHangingMuscle.cpp</a>.</dd>
</dl>

</div>
</div>
<a id="gaafa30bfd02f4d146b9ed2e3c19d9fef5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaafa30bfd02f4d146b9ed2e3c19d9fef5">&#9670;&nbsp;</a></span>checkLabelsMatchModelStates()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API void OpenSim::checkLabelsMatchModelStates </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>labels</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Throws an exception if any label in the provided list does not match any state variable names in the model. </p>

</div>
</div>
<a id="gaaaf7020b9b0d7d879e960cd5c2507e45"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaaaf7020b9b0d7d879e960cd5c2507e45">&#9670;&nbsp;</a></span>checkOrderSystemControls()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API void OpenSim::checkOrderSystemControls </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Throws an exception if the order of the controls in the model is not the same as the order of the actuators in the model. </p>

</div>
</div>
<a id="gaecd17fb05e682cd47504c7a2fafc223e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaecd17fb05e682cd47504c7a2fafc223e">&#9670;&nbsp;</a></span>createControlNamesFromModel() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::vector&lt;std::string&gt; OpenSim::createControlNamesFromModel </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Same as above, but when there is no mapping to the modelControlIndices. </p>

</div>
</div>
<a id="gaae85359eb9db792e3cc9d4a673e20086"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaae85359eb9db792e3cc9d4a673e20086">&#9670;&nbsp;</a></span>createControlNamesFromModel() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::vector&lt;std::string&gt; OpenSim::createControlNamesFromModel </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; int &gt; &amp;&#160;</td>
          <td class="paramname"><em>modelControlIndices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a vector of control names based on the actuators in the model for which appliesForce == True. </p>
<p>For actuators with one control (e.g. <a class="el" href="classOpenSim_1_1ScalarActuator.html" title="This is a derived class from the base class actuator (e.g., a torque motor, muscle,...">ScalarActuator</a>) the control name is simply the actuator name. For actuators with multiple controls, each control name is the actuator name appended by the control index (e.g. "/actuator_0"); modelControlIndices has length equal to the number of controls associated with actuators that apply a force (appliesForce == True). Its elements are the indices of the controls in the Model::updControls() that are associated with actuators that apply a force. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a808880626da2e126e7f14fa5cb3ae1eb">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addControlVariables()</a>.</p>

</div>
</div>
<a id="ga171fc46f228eddcb18c329f9b2b291fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga171fc46f228eddcb18c329f9b2b291fe">&#9670;&nbsp;</a></span>createStateVariableNamesInSystemOrder() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::vector&lt;std::string&gt; OpenSim::createStateVariableNamesInSystemOrder </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The map provides the index of each state variable in SimTK::State::getY() from its each state variable path string. </p>
<p>Empty slots in Y (e.g., for quaternions) are ignored. </p>

</div>
</div>
<a id="ga4cab0157fb7a49b050ca96aa39fac757"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga4cab0157fb7a49b050ca96aa39fac757">&#9670;&nbsp;</a></span>createStateVariableNamesInSystemOrder() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::vector&lt;std::string&gt; OpenSim::createStateVariableNamesInSystemOrder </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unordered_map&lt; int, int &gt; &amp;&#160;</td>
          <td class="paramname"><em>yIndexMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Same as above, but you can obtain a map from the returned state variable names to the index in SimTK::State::getY() that accounts for empty slots in Y. </p>

</div>
</div>
<a id="gad093fdec14dd81460d5b8a698f7e0e1a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gad093fdec14dd81460d5b8a698f7e0e1a">&#9670;&nbsp;</a></span>createSyntheticIMUAccelerationSignals()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API <a class="el" href="namespaceOpenSim.html#aca67cce5245fc8a1ac274999aa98deb6">TimeSeriesTableVec3</a> OpenSim::createSyntheticIMUAccelerationSignals </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>statesTable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>controlsTable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>framePaths</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculate "synthetic" acceleration signals equivalent to signals recorded from inertial measurement units (IMUs). </p>
<p>First, this utility computes the linear acceleration for each frame included in 'framePaths' using <a class="el" href="classOpenSim_1_1Frame.html" title="A Frame is an OpenSim representation of a reference frame.">Frame</a>'s 'linear_acceleration' <a class="el" href="classOpenSim_1_1Output.html">Output</a>. Then, to mimic acceleration signals measured from IMUs, the model's gravitational acceleration vector is subtracted from the linear accelerations and the resulting accelerations are re-expressed in the bases of the associated <a class="el" href="classOpenSim_1_1Frame.html" title="A Frame is an OpenSim representation of a reference frame.">Frame</a>s.</p>
<dl class="section note"><dt>Note</dt><dd>The linear acceleration <a class="el" href="classOpenSim_1_1Output.html">Output</a>s are computed using the <a class="el" href="group__simulationutil.html#gabadb22afcecdebfaa78d9a95bd35d336" title="Calculate the requested outputs using the model in the problem and the provided states and controls t...">analyze()</a> simulation utility, and therefore the 'statesTable' and 'controlsTable' arguments must contain the same time points and we assume that the states obey any kinematic constraints in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>.</dd>
<dd>
The passed in model must have the correct mass and inertia properties included, since computing accelerations requires realizing to SimTK::Stage::Acceleration which depends on SimTK::Stage::Dynamics. </dd></dl>

</div>
</div>
<a id="gada84ed9ec5e455b9861259845f7454ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gada84ed9ec5e455b9861259845f7454ed">&#9670;&nbsp;</a></span>createSystemControlIndexMap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::unordered_map&lt;std::string, int&gt; OpenSim::createSystemControlIndexMap </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The map provides the index of each control variable in the SimTK::Vector returned by Model::getControls(), using the control name as the key. </p>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if the order of actuators in the model does not match the order of controls in Model::getControls(). This is an internal error, but you may be able to avoid the error by ensuring all <a class="el" href="classOpenSim_1_1Actuator.html" title="Base class for an actuator (e.g., a torque motor, muscle, ...) that requires a generic external input...">Actuator</a>s are in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>'s <a class="el" href="classOpenSim_1_1ForceSet.html" title="A class for holding and managing a set of forces for a model.">ForceSet</a>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga49570bae937f5adf405c811da8ed9329"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga49570bae937f5adf405c811da8ed9329">&#9670;&nbsp;</a></span>createSystemYIndexMap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::unordered_map&lt;std::string, int&gt; OpenSim::createSystemYIndexMap </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The map provides the index of each state variable in SimTK::State::getY() from its state variable path string. </p>

</div>
</div>
<a id="ga5821a4ca8e6fe9b0cb2b5492665b5dc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga5821a4ca8e6fe9b0cb2b5492665b5dc0">&#9670;&nbsp;</a></span>simulate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API SimTK::State OpenSim::simulate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>initialState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>finalTime</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>saveStatesFile</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Simulate a model from an initial state and return the final state. </p>
<p>If the model's useVisualizer flag is true, the user is repeatedly prompted to either begin simulating or quit. The provided state is not updated but the final state is returned at the end of the simulation, when finalTime is reached. Set saveStatesFile=true to save the states to a storage file as: "&lt;model_name&gt;_states.sto". </p>
<dl class="section examples"><dt>Examples</dt><dd><a class="el" href="example2DWalking_8m-example.html#a0">example2DWalking.m</a>.</dd>
</dl>

</div>
</div>
<a id="ga3393a1f7ac64c05305059ed37b2810f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga3393a1f7ac64c05305059ed37b2810f3">&#9670;&nbsp;</a></span>updatePre40KinematicsFilesFor40MotionType()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API void OpenSim::updatePre40KinematicsFilesFor40MotionType </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>filePaths</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>suffix</em> = <code>&quot;_updated&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function can be used to upgrade MOT files generated with versions before 4.0 in which some data columns are associated with coordinates that were incorrectly marked as Rotational (rather than Coupled). </p>
<p>Specific instances of the issue are the patella coordinate in the Rajagopal 2015 and leg6dof9musc models. In these cases, the patella will visualize incorrectly in the GUI when replaying the kinematics from the MOT file, and Static Optimization will yield incorrect results.</p>
<p>The new files are written to the same directories as the original files, but with the provided suffix (before the file extension). To overwrite your original files, set the suffix to an emtpty string.</p>
<p>If the file does not need to be updated, no new file is written.</p>
<p>Conversion of the data only occurs for files in degrees ("inDegrees=yes" in the header).</p>
<p>Do not use this function with MOT files generated by 4.0 or later; doing so will cause your data to be altered incorrectly. We do not detect whether or not your MOT file is pre-4.0.</p>
<p>In <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> 4.0, MotionTypes for Coordinates are now determined strictly by the coordinates' owning <a class="el" href="classOpenSim_1_1Joint.html" title="An OpenSim Joint is an OpenSim::ModelComponent which connects two PhysicalFrames together and specifi...">Joint</a>. In older models, the MotionType, particularly for CustomJoints, were user- specified. That entailed in some cases, incorrectly labeling a <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">Coordinate</a> as being Rotational, for example, when it is in fact Coupled. For the above models, for example, the patella <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">Coordinate</a> had been user-specified to be Rotational, but the angle of the patella about the Z-axis of the patella body, is a spline function (e.g. coupled function) of the patella <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">Coordinate</a>. Thus, the patella <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">Coordinate</a> is not an angle measurement and is not classified as Rotational. Use this utility to remove any unit conversions from Coordinates that were incorrectly labeled as Rotational in the past. For these Coordinates only, the utility will undo the incorrect radians to degrees conversion. </p>

</div>
</div>
<a id="gaf356001ef168c7f34808f60e493b2b05"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaf356001ef168c7f34808f60e493b2b05">&#9670;&nbsp;</a></span>updatePre40KinematicsStorageFor40MotionType()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API std::unique_ptr&lt;<a class="el" href="classOpenSim_1_1Storage.html">Storage</a>&gt; OpenSim::updatePre40KinematicsStorageFor40MotionType </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>pre40Model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Storage.html">Storage</a> &amp;&#160;</td>
          <td class="paramname"><em>kinematics</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Not available through scripting. </p>
<dl class="section return"><dt>Returns</dt><dd>nullptr if no update is necessary. </dd></dl>

</div>
</div>
<a id="gaa56d59a1be9785c9b51e65716ab4ec66"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa56d59a1be9785c9b51e65716ab4ec66">&#9670;&nbsp;</a></span>updateSocketConnecteesBySearch()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API void OpenSim::updateSocketConnecteesBySearch </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function attempts to update the connectee path for any <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> anywhere in the model whose connectee path does not point to an existing component. </p>
<p>The paths are updated by searching the model for a component with the correct name. For example, a connectee path like <code>../../some/invalid/path/to/foo</code> will be updated to <code>/bodyset/foo</code> if a <a class="el" href="classOpenSim_1_1Body.html" title="An OpenSim::Body is a PhysicalFrame (reference frame) with associated inertia specified by its mass,...">Body</a> named <code>foo</code> exists in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>'s <a class="el" href="classOpenSim_1_1BodySet.html" title="A class for holding a set of bodies.">BodySet</a>. If a socket specifies a <a class="el" href="classOpenSim_1_1Body.html" title="An OpenSim::Body is a PhysicalFrame (reference frame) with associated inertia specified by its mass,...">Body</a> <code>foo</code> and more than one <a class="el" href="classOpenSim_1_1Body.html" title="An OpenSim::Body is a PhysicalFrame (reference frame) with associated inertia specified by its mass,...">Body</a> <code>foo</code> exists in the model, we emit a warning and the socket that specified <code>foo</code> is not altered.</p>
<p>This method is intended for use with models loaded from version-30516 XML files to bring them up to date with the 4.0 interface. </p>

</div>
</div>
<a id="ga871b1293a7c10c0d9f7358b0d7db83ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga871b1293a7c10c0d9f7358b0d7db83ed">&#9670;&nbsp;</a></span>updateStateLabels40()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMSIMULATION_API void OpenSim::updateStateLabels40 </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>labels</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update a vector of state labels (in place) to use post-4.0 state paths instead of pre-4.0 state names. </p>
<p>For example, this converts labels as follows:</p><ul>
<li><code>pelvis_tilt</code> -&gt; <code>/jointset/ground_pelvis/pelvis_tilt/value</code></li>
<li><code>pelvis_tilt_u</code> -&gt; <code>/jointset/ground_pelvis/pelvis_tilt/speed</code></li>
<li><code>soleus.activation</code> -&gt; <code>/forceset/soleus/activation</code></li>
<li><code>soleus.fiber_length</code> -&gt; <code>/forceset/soleus/fiber_length</code> This can also be used to update the column labels of an Inverse <a class="el" href="classOpenSim_1_1Kinematics.html" title="A class for recording the kinematics of the generalized coordinates of a model during a simulation.">Kinematics</a> <a class="el" href="classOpenSim_1_1Tool.html" title="A Tool is an OpenSim abstraction that encapsulates an analysis or series of modeling and analysis ste...">Tool</a> solution MOT file so that the data can be used as states. If a label does not identify a state in the model, the column label is not changed. <dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if labels are not unique. </td></tr>
  </table>
  </dd>
</dl>
</li>
</ul>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1TabOpUseAbsoluteStateNames.html#a1a42bf3c12a1bfd45e009cc3336e6f1d">OpenSim::TabOpUseAbsoluteStateNames::operate()</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:40 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
